#!/usr/bin/env python
import mincemeat

with open("slava.txt") as f:
    content = f.readlines()
data = [x.strip() for x in content]
datasource = dict(enumerate(data))

def mapfn(k, v):
	d = v.split("->")
	friends = set(d[1].strip().split(" "))
	for w in friends:
		first = d[0].strip()
		second = w
		if first > second:
			temp = first
			first = second
			second = temp
		yield (first, second), friends

def reducefn(k, vs):
	ret = vs[0]
	for s in vs:
		ret = ret.intersection(s)
	return ret

s = mincemeat.Server()
s.datasource = datasource
s.mapfn = mapfn
s.reducefn = reducefn

results = s.run_server(password="pass")

for r in results:
	print(r,"->",results[r])
